module M where

-- Insert your favorite kind of expression here...
data Expr = Entier Int | Mult Expr Expr | Div Expr Expr

eval :: Expr -> Int
eval (Entier i) = i
eval (Mult e f) = (eval e) * (eval f)
eval (Div e f) = (eval e) `div` (eval f)

-- We will consider two extensions of this evaluator:
-- 1) raise a proper catchable exception for divisions by zero
-- 2) increment a counter for each arithmetic operation
